#include <windows.h>

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szCmdLine, int iCmdShow )
{
   LONG lSymbol;
   LONG CALLBACK ( * pDllGetSymbol )( char * );
   void CALLBACK ( * pDllPutSymbol )( LONG );
   void CALLBACK ( * pDllDo )( LONG );

   hInstance = LoadLibrary( "Random.dll" );

   if( hInstance != NULL )
   {
      MessageBox( NULL, "Dll cargada.", "Informacin", MB_OK );
      pDllGetSymbol = ( LONG CALLBACK ( * ) ( char * ) ) GetProcAddress( hInstance, "DllGetSymbol" );
      pDllPutSymbol = ( void CALLBACK ( * ) ( LONG ) ) GetProcAddress( hInstance, "DllPutSymbol" );
      pDllDo = ( void CALLBACK ( * ) ( LONG ) ) GetProcAddress( hInstance, "DllDo" );

      if( pDllGetSymbol != NULL && pDllPutSymbol != NULL && pDllDo != NULL )
      {
         lSymbol = pDllGetSymbol( "Test1" );

         if( lSymbol != 0 )
         {
            pDllPutSymbol( lSymbol );
            pDllDo( 0 );
         }

         MessageBox( NULL, "Ahora lanzamos el proyecto completo.", "Informacin", MB_OK );
         lSymbol = pDllGetSymbol( "Main" );

         if( lSymbol != 0 )
         {
            pDllPutSymbol( lSymbol );
            pDllDo( 0 );
         }
      }

      FreeLibrary( hInstance );
      MessageBox( NULL, "Dll descargada.", "Informacin", MB_OK );
   }

   return 0;
}