program DesdeDelphi;

uses
  Windows;

{$R *.res}

type
   TDllGetSymbol = function( Name: PChar ): Longint; stdcall;
   TDllPutSymbol = procedure( Symbol: Longint ); stdcall;
   TDllDo = procedure( Params: Longint ); stdcall;

var
   hModule: THandle;
   pDllGetSymbol: TDllGetSymbol;
   pDllPutSymbol: TDllPutSymbol;
   pDllDo: TDllDo;
   lSymbol: Longint;

begin

   hModule := LoadLibrary( 'Random.dll' );

   if hModule <> 0 then
   begin
      MessageBox( 0, 'Dll cargada.', 'Informacin', MB_OK );
      @pDllGetSymbol := GetProcAddress( hModule, 'DllGetSymbol' );
      @pDllPutSymbol := GetProcAddress( hModule, 'DllPutSymbol' );
      @pDllDo := GetProcAddress( hModule, 'DllDo' );

      if ( @pDllGetSymbol <> nil ) and ( @pDllPutSymbol <> nil ) and ( @pDllDo <> nil ) then
      begin
         lSymbol := pDllGetSymbol( 'Test1' );

         if lSymbol <> 0 then
         begin
            pDllPutSymbol( lSymbol );
            pDllDo( 0 );
         end;

         MessageBox( 0, 'Ahora lanzamos el proyecto completo.', 'Informacin', MB_OK );
         lSymbol := pDllGetSymbol( 'Main' );

         if lSymbol <> 0 then
         begin
            pDllPutSymbol( lSymbol );
            pDllDo( 0 );
         end;
      end;

      FreeLibrary( hModule );
      MessageBox( 0, 'Dll descargada.', 'Informacin', MB_OK );
   end;
end.
